unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus,
  Vcl.StdCtrls, VclTee.TeEngine, Vcl.ExtCtrls, VclTee.TeeProcs, VclTee.Chart, VclTee.Series, VclTee.TeePolar, VclTee.TeeLisB, Vcl.Buttons, VclTee.TeeEdiGrad,
  Vcl.Imaging.jpeg, VclTee.TeePoin3, VclTee.TeeTools, VclTee.TeeSurfa;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    ButtonExit: TButton;
    ChartListBox1: TChartListBox;
    Series1: TPoint3DSeries;
    CheckBox10: TCheckBox;
    ChartTool1: TNearestTool;
    ChartTool2: TAnnotationTool;
    procedure FormCreate(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure ChartListBox1Click(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    CalloutDynamArray: array [0 .. 5, 0 .. 100] of string;
    Procedure SetCallout(AIndex: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  with Chart1 do
    begin
      View3D := true;
      View3DWalls := true;
      Chart3DPercent := 100;
      View3DOptions.Zoom := 60;
      View3DOptions.Orthogonal := false;
      Legend.Visible := false;
      Title.Visible := false;
    end;
  ChartTool1.Style := hsCircle;

  if Chart1.SeriesCount > 0 then
    Chart1.FreeAllSeries();
  for i := 0 to 2 do
    begin
      with Chart1 do
        begin
          AddSeries(TPoint3DSeries);
          with (Series[SeriesCount - 1] as TPoint3DSeries) do
            begin
              FillSampleValues;
              LinePen.Visible := true;
              LinePen.Style := psSolid;
              LinePen.Color := Color;
              LinePen.Width := 2;
              Pointer.Visible := false;
            end;
        end;
    end;
  ChartListBox1.FontSeriesColor := true;
  ChartListBox1.SelectedSeries := Chart1.Series[0];
end;

procedure TForm1.FormShow(Sender: TObject);
var
  i, j: Integer;
begin
  for i := 0 to 2 do
    for j := 0 to 50 do
      CalloutDynamArray[i, j] := 'A=A' + IntToStr(i) + IntToStr(j) + #13#10 + 'B=B' + IntToStr(i) + IntToStr(j) + #13#10 + 'C=C' + IntToStr(i) + IntToStr(j) +
        #13#10 + 'D=D' + IntToStr(i) + IntToStr(j) + #13#10 + 'E=E' + IntToStr(i) + IntToStr(j) + #13#10 + 'B=B' + IntToStr(i) + IntToStr(j) + #13#10;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  tmp: Integer;
begin
  if CheckBox10.Checked and (ChartListBox1.SelectedSeries <> nil) then
    begin
      tmp := ChartTool1.GetNearestPoint(ChartListBox1.SelectedSeries, X, Y);
      if tmp <> -1 then
        SetCallout(tmp);
    end;
end;

Procedure TForm1.SetCallout(AIndex: Integer);
begin
  ChartTool2.Text := CalloutDynamArray[ChartListBox1.SelectedSeries.SeriesIndex, AIndex];
  with ChartTool2.Callout do
    begin
      Visible := true;
      XPosition := ChartListBox1.SelectedSeries.CalcXPos(AIndex);
      YPosition := ChartListBox1.SelectedSeries.CalcYPos(AIndex);
      ZPosition := 0; // the problem may be in here!!!
    end;
end;

procedure TForm1.ChartListBox1Click(Sender: TObject);
begin
  ChartTool1.Series := ChartListBox1.SelectedSeries;
end;

procedure TForm1.CheckBox10Click(Sender: TObject);
begin
  ChartTool1.Active := CheckBox10.Checked;
  ChartTool2.Active := CheckBox10.Checked;
end;

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
  close;
end;

end.
